<?php

w3_require_once(W3TC_LIB_W3_DIR . '/PgCacheFlush.php');

/**
 * Class Xoogu_W3_PgCacheFlush
 *
 * Technically speaking, this class should be a copy of W3_PgCacheFlush instead
 * of extending it, since most of the methods in W3_PgCacheFlush are presumably
 * meant to be private, including the one we need to override. But if they are
 * just meant to be protected, then this should be OK.
 */
class Xoogu_W3_PgCacheFlush extends W3_PgCacheFlush {

	/**
     * PHP5 Constructor
     */
    function __construct() {
        parent::__construct();
    }

    /**
     * Flush a single url
     * @param $url
     * @param $cache
     * @param $mobile_groups
     * @param $referrer_groups
     * @param $encryptions
     * @param $compressions
     */
    function _flush_url($url, $cache, $mobile_groups, $referrer_groups, $encryptions, $compressions) {
		//backup the real GeoIP country code
		if (isset($_SERVER['GEOIP_COUNTRY_CODE'])) {
			$geoip_country_code = $_SERVER['GEOIP_COUNTRY_CODE'];
		}
		//list of country codes we need to clear cached files for
		$aCountries = w3tc_get_extension_config('xoogu-geotarget-w3tc', 'countries', null, array());
		foreach ($mobile_groups as $mobile_group) {
            foreach ($referrer_groups as $referrer_group) {
                foreach ($encryptions as $encryption) {
                    foreach ($compressions as $compression) {
                        $page_key = $this->_get_page_key($mobile_group, $referrer_group, $encryption, $compression, false, $url);
						//by force setting the $_SERVER['GEOIP_COUNTRY_CODE'] to each country code in turn, the correct page key can be generated for each country, and so the cached page for that country will be removed (set to .old)
						foreach ($aCountries as $sCountry) {
							$_SERVER['GEOIP_COUNTRY_CODE'] = $sCountry;
							$cache->delete($page_key);
						}
                    }
                }
            }
        }
		//reset the GeoIP country code back to the genuine value
		if (isset($geoip_country_code)) {
			$_SERVER['GEOIP_COUNTRY_CODE'] = $geoip_country_code;
		} else {
			unset($_SERVER['GEOIP_COUNTRY_CODE']);
		}
		
    }
}
